# openapi-client
API documentation for the Zedblock

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0
- Package version: 1.0.0
- Generator version: 7.12.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import openapi_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import openapi_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import openapi_client
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.zedblock.com/api
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "https://api.zedblock.com/api"
)



# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.BoardApi(api_client)
    create_board_dto = openapi_client.CreateBoardDto() # CreateBoardDto | Board creation payload.

    try:
        # Create Board
        api_instance.board_controller_create_stage(create_board_dto)
    except ApiException as e:
        print("Exception when calling BoardApi->board_controller_create_stage: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.zedblock.com/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BoardApi* | [**board_controller_create_stage**](docs/BoardApi.md#board_controller_create_stage) | **POST** /board/create | Create Board
*BoardApi* | [**board_controller_delete_stage**](docs/BoardApi.md#board_controller_delete_stage) | **DELETE** /board/deleteBoard | Delete Customer Board
*BoardApi* | [**board_controller_delete_task**](docs/BoardApi.md#board_controller_delete_task) | **POST** /board/deleteBoardItem/{id} | Delete board item
*BoardApi* | [**board_controller_get_all_boards**](docs/BoardApi.md#board_controller_get_all_boards) | **GET** /board/getAllBoards | Get All Boards
*BoardApi* | [**board_controller_get_board_component_detailsoard_item**](docs/BoardApi.md#board_controller_get_board_component_detailsoard_item) | **GET** /board/getSingleBoardItemDetails/{boardId} | Get Single Board Item
*BoardApi* | [**board_controller_get_board_details**](docs/BoardApi.md#board_controller_get_board_details) | **GET** /board/getBoardDetails/{boardId} | Get Single Board
*BoardApi* | [**board_controller_get_board_items**](docs/BoardApi.md#board_controller_get_board_items) | **GET** /board/listBoardItemsByStatus | Get Board Items
*BoardApi* | [**board_controller_get_board_items_by_status**](docs/BoardApi.md#board_controller_get_board_items_by_status) | **GET** /board/boardItems/{status}/page | Get Board Items for specific status
*BoardApi* | [**board_controller_get_particular_data_of_all_board_item**](docs/BoardApi.md#board_controller_get_particular_data_of_all_board_item) | **GET** /board/getPhoneAndEmailInBoardItem/{boardId} | Get Phones and email used in particular board item using type
*BoardApi* | [**board_controller_get_statuses_of_board**](docs/BoardApi.md#board_controller_get_statuses_of_board) | **GET** /board/getboardStatus | 
*BoardApi* | [**board_controller_update_board**](docs/BoardApi.md#board_controller_update_board) | **PUT** /board/updateBoard | Update Customer Board
*BoardApi* | [**board_controller_update_board_item**](docs/BoardApi.md#board_controller_update_board_item) | **PUT** /board/updateBoardItem | Update Customer Board
*BoardApi* | [**board_controller_update_status**](docs/BoardApi.md#board_controller_update_status) | **PUT** /board/updateSingleBoardItemStatus | Update the status of a board item
*BoardApi* | [**board_controller_update_status_component**](docs/BoardApi.md#board_controller_update_status_component) | **PUT** /board/updateStatusComponent/{id} | Update status of the board
*BoardApi* | [**board_controller_update_table_component_from_agent**](docs/BoardApi.md#board_controller_update_table_component_from_agent) | **PUT** /board/updateSingleBoardItem/{boardId}/{boardItemId} | Update board item  components
*BoardApi* | [**board_controller_update_task**](docs/BoardApi.md#board_controller_update_task) | **PUT** /board/updateBoardItem/{boardItemId} | Update board item


## Documentation For Models

 - [ComponentDto](docs/ComponentDto.md)
 - [CreateBoardDto](docs/CreateBoardDto.md)
 - [DeleteBoardDTO](docs/DeleteBoardDTO.md)
 - [DeleteBoardItemDto](docs/DeleteBoardItemDto.md)
 - [StatusDto](docs/StatusDto.md)
 - [TemplateDto](docs/TemplateDto.md)
 - [UpdateBoardDTO](docs/UpdateBoardDTO.md)
 - [UpdateBoardItemDTO](docs/UpdateBoardItemDTO.md)
 - [UpdateStatusDTO](docs/UpdateStatusDTO.md)
 - [UpdateStatusDto](docs/UpdateStatusDto.md)
 - [UpdateTableComponentFromAgent](docs/UpdateTableComponentFromAgent.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




