# coding: utf-8

"""
    Zedblock Apis

    API documentation for the Zedblock

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.component_dto import ComponentDto
from openapi_client.models.template_dto import TemplateDto
from typing import Optional, Set
from typing_extensions import Self

class CreateBoardDto(BaseModel):
    """
    CreateBoardDto
    """ # noqa: E501
    title: StrictStr = Field(description="Name of the board")
    status: Optional[StrictStr] = Field(default=None, description="Status of the board")
    assignees: Optional[List[StrictStr]] = Field(default=None, description="List of assignees")
    description: Optional[StrictStr] = Field(default=None, description="Description of the Board")
    color: StrictStr = Field(description="Color associated with the board")
    template: TemplateDto = Field(description="Id of the table template")
    components: Optional[List[ComponentDto]] = Field(default=None, description="Components associated with the template")
    is_create_board_items: Optional[StrictBool] = Field(default=None, description="Customer associated with the board", alias="isCreateBoardItems")
    __properties: ClassVar[List[str]] = ["title", "status", "assignees", "description", "color", "template", "components", "isCreateBoardItems"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Prospecting', 'Negotiation', 'Agreement Signed', 'Active Partnership', 'Ended', 'Not Started', 'In Progress', 'Pending Review', 'Compliant', 'Non-Compliant', 'Planning', 'Testing', 'Launched', 'Completed', 'Draft', 'In Review', 'Approved', 'Published', 'Archived', 'Recruitment', 'Onboarding', 'Active', 'Leave of Absence', 'Terminated', 'New', 'Engaged', 'Inactive', 'VIP', 'Churned', 'Awaiting Approval', 'Paid', 'Overdue', 'Cancelled', 'Idea', 'In Design', 'In Development', 'Ready for Launch', 'Discontinued', 'Pending', 'Processing', 'Shipped', 'Delivered', 'Returned', 'Contacted', 'Qualified', 'Proposal Sent', 'Won', 'Lost', 'Open', 'Escalated', 'Pending Customer Response', 'Resolved', 'Closed']):
            raise ValueError("must be one of enum values ('Prospecting', 'Negotiation', 'Agreement Signed', 'Active Partnership', 'Ended', 'Not Started', 'In Progress', 'Pending Review', 'Compliant', 'Non-Compliant', 'Planning', 'Testing', 'Launched', 'Completed', 'Draft', 'In Review', 'Approved', 'Published', 'Archived', 'Recruitment', 'Onboarding', 'Active', 'Leave of Absence', 'Terminated', 'New', 'Engaged', 'Inactive', 'VIP', 'Churned', 'Awaiting Approval', 'Paid', 'Overdue', 'Cancelled', 'Idea', 'In Design', 'In Development', 'Ready for Launch', 'Discontinued', 'Pending', 'Processing', 'Shipped', 'Delivered', 'Returned', 'Contacted', 'Qualified', 'Proposal Sent', 'Won', 'Lost', 'Open', 'Escalated', 'Pending Customer Response', 'Resolved', 'Closed')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateBoardDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of template
        if self.template:
            _dict['template'] = self.template.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in components (list)
        _items = []
        if self.components:
            for _item_components in self.components:
                if _item_components:
                    _items.append(_item_components.to_dict())
            _dict['components'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateBoardDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "title": obj.get("title"),
            "status": obj.get("status"),
            "assignees": obj.get("assignees"),
            "description": obj.get("description"),
            "color": obj.get("color"),
            "template": TemplateDto.from_dict(obj["template"]) if obj.get("template") is not None else None,
            "components": [ComponentDto.from_dict(_item) for _item in obj["components"]] if obj.get("components") is not None else None,
            "isCreateBoardItems": obj.get("isCreateBoardItems")
        })
        return _obj


